.. index::
    single: Developer Practices

=========================
Adopt Developer Practices
=========================

------------------------------
1. Adapt to Change & Feedback
------------------------------

We can improve both the content of documentation and the efficiency of how it is created.

Most teams already have ways to get feedback on their content.
The basic requirements for an agile change control process.


1. The need is captured into a request (this includes bug reports)
2. The request is triaged so that a definitive decision is made and a priority assigned
3. Work is completed
4. The work is verified using a combination of reviews and testing
5. Deployment occurs


NOTE:

    A developer style workflow will be useful for your Docs As Code process.
    **However** it may not be the same workflow used by your product engineers.
    Be careful to adapt processes and ways of working to the specific requirements
    of your technical writing projects.

--------------------------
2. Change Review Process
--------------------------

Using similar change control processed across both documentation and product
development artifacts gives a number of benefits

.. <!-- alex ignore joint -->

#.  Single process for everyone on the team
#.  Single set of tools
#.  Documentation and product changes can be discussed in the same
    forum and joint impacts understood

-----------------------------------
3. Use Developer Design Practices
-----------------------------------

* Use an agile story based approach to manage documentation design and purpose
  Using the same language as your development team to answer The who, what and how questions.

.. #TODO -- needs a lot more explanation.

-------------------------------------------
4. Create a tight edit/review feedback loop
-------------------------------------------

Developers benefit from a fast feedback loop with local tooling and easy to run unit tests
so that they get immediate feedback to code changes. We need to provide the same
features for writers.

The components required for this will depend on the publishing platform being used.

For example the Hugo static site generator has a
`LiveReload <https://gohugo.io/getting-started/usage/#livereload>`_ feature and
Sphinx has a ``sphinx-reload`` package.

However generally these will not refresh content that is generated by tools other than the static site generator,
and additional plumping is required.

For example a Makefile target can be created that uses `fswatch <https://emcrisostomo.github.io/fswatch/>`_
to regenerate any other content as required (via a sub-make)

.. literalinclude:: ../docker-build-context/Makefile
    :language: Make
    :lines: 26-29
